from typing import Callable

import discord

from v6d2ctx.context import Context, Explicit, Implicit, command_type
from v6d2ctx.handle_command import handle_command


async def handle_args(of: Callable[[str], command_type], message: discord.Message, args: list[str], client: discord.Client):
    match args:
        case []:
            return
        case [command_name, *command_args]:
            ctx = Context(message, client)
            try:
                await handle_command(of, ctx, command_name, command_args)
            except Implicit:
                pass
            except Explicit as e:
                await ctx.reply(e.msg)
